Index: pykota/trunk/debian/control
===================================================================
--- pykota/trunk/debian/control (revision 1350)
+++ pykota/trunk/debian/control (revision 1350)
@@ -0,0 +1,13 @@
+Source: pykota
+Section: text
+Priority: extra
+Maintainer: Peter Hawkins <peterh@debian.org>
+Build-Depends-Indep: debhelper (>= 4.0.0), python, docbook-utils
+Standards-Version: 3.6.1
+
+Package: pykota
+Architecture: all
+Depends: ${python:Depends}, python-egenix-mxdatetime, cupsys | lprng, python-pygresql | python-ldap
+Recommends: snmp, netatalk
+Description: Print Quota/Accounting system for CUPS and LPRng
+ FIXME: Description
Index: pykota/trunk/debian/links
===================================================================
--- pykota/trunk/debian/links (revision 1350)
+++ pykota/trunk/debian/links (revision 1350)
@@ -0,0 +1,1 @@
+usr/share/pykota/cupspykota usr/lib/cups/backend/cupspykota 
Index: pykota/trunk/debian/dirs
===================================================================
--- pykota/trunk/debian/dirs (revision 1350)
+++ pykota/trunk/debian/dirs (revision 1350)
@@ -0,0 +1,5 @@
+usr/bin
+usr/share/pykota
+usr/lib/cups/backend
+etc/pykota
+etc/default
Index: pykota/trunk/debian/Makefile.docs
===================================================================
--- pykota/trunk/debian/Makefile.docs (revision 1350)
+++ pykota/trunk/debian/Makefile.docs (revision 1350)
@@ -0,0 +1,15 @@
+DESTDIR=
+
+all: build
+
+build: build-stamp
+build-stamp:
+       docbook2html pykota.sgml
+       touch build-stamp
+
+install: build
+       mkdir -p $(DESTDIR)/usr/share/doc/pykota/html/
+       cp *.html $(DESTDIR)/usr/share/doc/pykota/html/
+
+clean:
+       rm -f *.html build-stamp
Index: pykota/trunk/debian/changelog
===================================================================
--- pykota/trunk/debian/changelog (revision 1350)
+++ pykota/trunk/debian/changelog (revision 1350)
@@ -0,0 +1,6 @@
+pykota (1.16.cvs.20040119-1) unstable; urgency=low
+
+  * Initial Release.
+
+ -- Peter Hawkins <peterh@debian.org>  Mon, 19 Jan 2004 20:03:43 +1100
+
Index: pykota/trunk/debian/copyright
===================================================================
--- pykota/trunk/debian/copyright (revision 1350)
+++ pykota/trunk/debian/copyright (revision 1350)
@@ -0,0 +1,123 @@
+This package was debianized by Peter Hawkins <peterh@debian.org> on
+Tue, 18 Nov 2003 14:47:59 +1100.
+
+It was downloaded from:
+http://www.librelogiciel.com/software/PyKota/Presentation/action_Presentation
+(CVS snapshot)
+
+Upstream Authors: Jeroma Alet <alet@librelogiciel.com>
+
+Copyright:
+(c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License with
+your Debian GNU/Linux system, in /usr/share/common-licenses/GPL, or with
+the Debian GNU/Linux pykota source package as the file COPYING.  If not,
+write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
+Boston, MA 02111-1307, USA.
+
+
+The file LICENSE in the source tree contains the instructions which are
+included below.
+The author's wishes do not make the software DFSG non-free, since the
+official/non-official distinction is a request, not a requirement. That said,
+the debian package complies with the author's wishes and is labelled as
+unofficial; I encourage you to support free software and buy an official
+version if pykota turns out to be useful for you.
+
+============================================================
+Download :
+
+  * PyKota is distributed under the "GNU General Public License":/GPL
+
+  * You can access to PyKota's source code by using CVS from :
+  
+      "http://savannah.nongnu.org/cvs/?group=pykota":http://savannah.nongnu.org/cvs/?group=pykota
+
+    Then follow the instructions in the section labeled "Getting a Copy of the CVS Repository". 
+
+  * Clients who purchased an **Official PyKota Package** can directly access to "the tarballs HERE":/software/PyKota/tarballs .
+               
+Why no tarball is available for free :
+
+  * The CVS version will always be labelled as **unofficial** and the word **unofficial**
+    will appear whenever you run PyKota command line tools with the *--version* command line
+    argument.
+
+  * I ask you to not label or present a version of PyKota downloaded 
+    from CVS as being the 'OFFICIAL' one. 
+
+  * I encourage you to buy an 'OFFICIAL' PyKota package. See below for 
+    the benefits of doing so. 
+
+  * A PyKota version obtained either from CVS (unofficial) or by 
+    purchasing an official package, **IS FREELY REDISTRIBUTABLE AND 
+    MODIFIABLE, AT NO COST, UNDER THE TERMS OF THE GNU GENERAL PUBLIC 
+    LICENSE.** 
+
+  * Version number excepted, **THERE'S NO SOURCE CODE DIFFERENCE 
+    BETWEEN 'OFFICIAL' AND 'UNOFFICIAL' VERSIONS OF PyKota.** However it 
+    should be clear to you that the latest version you can find in CVS 
+    may be somewhat unstable or unfinished, since this software is a 
+    work in progress, and that it's up to you to download working 
+    revisions from the CVS tree. That's why I suggest that you purchase 
+    an **'OFFICIAL'** version, because it will be simpler for you (and 
+    better for me). Also the documentation included in the 
+    **'UNOFFICIAL'** version is only delivered in DocBook XML/SGML 
+    source form, and not in compiled forms like HTML or PDF. 
+
+  * You can obtain an **'OFFICIAL'** version of PyKota in two forms :
+
+    * Electronic form :
+
+      * You pay me any amount of money starting at **15$ (US Dollars)**
+
+      * Then I send you the latest **PyKota 'OFFICIAL'** tarball, 
+        including the latest version of the electronic documentation in 
+        SGML, HTML and PDF formats, by email. 
+
+    * CDROM + Paper documentation *(not yet available, documentation 
+      still under works)* : 
+
+      * You pay me any amount of money starting at **30$ (US Dollars)**
+
+      * Then I send you the latest **PyKota 'OFFICIAL'** tarball, 
+        including the latest version of the electronic documentation in 
+        SGML, HTML and PDF formats, on CDROM, accompanied with the latest 
+        version of the printed documentation. No additionnal shipping costs 
+        will be asked to you, unless you require a specific delivery mode. 
+
+  * The "purchase":/software/PyKota/Purchase of an **'OFFICIAL'** 
+    version also allows you to : 
+
+    * Modify or redistribute the **'OFFICIAL'** version you purchased, 
+      under the terms of the GNU General Public License of the Free 
+      Software Foundation. I just ask you to remove the 'OFFICIAL' word 
+      from the version number if you redistribute a modified official 
+      version. 
+
+    * Obtain free technical support for a year starting at your purchase 
+      date : This includes bug fixes and new official versions, as well as 
+      priority email support. 
+
+    * Obtain half of **your money back** in case you contribute source 
+      code or documentation which I accept in the source tree. If you're a 
+      motivated developper, you've got strong chances to get half of your 
+      money back. *NB : You will have to send me a signed copyright 
+      assignment on paper in order for me to be able to accept your 
+      patches on PyKota.* 
+
+    * By purchasing an official package, your karma will also be better.
+
+I sincerely hope that you will find this proposition as fair as I do 
+think it is. 
+
Index: pykota/trunk/debian/docs
===================================================================
--- pykota/trunk/debian/docs (revision 1350)
+++ pykota/trunk/debian/docs (revision 1350)
@@ -0,0 +1,7 @@
+FAQ
+NEWS
+README
+TODO
+SECURITY
+initscripts/postgresql/README.postgresql
+initscripts/ldap/README.ldap
Index: pykota/trunk/debian/rules
===================================================================
--- pykota/trunk/debian/rules (revision 1350)
+++ pykota/trunk/debian/rules (revision 1350)
@@ -0,0 +1,84 @@
+#!/usr/bin/make -f
+# -*- makefile -*-
+# Sample debian/rules that uses debhelper.
+# GNU copyright 1997 to 1999 by Joey Hess.
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+export DH_COMPAT=3
+
+
+build: build-stamp
+build-stamp: 
+       dh_testdir
+
+       #/usr/bin/docbook-to-man debian/pykota.sgml > pykota.1
+       /usr/bin/python setup.py build
+       (cd docs; make -f ../debian/Makefile.docs build)
+
+       touch build-stamp
+
+clean:
+       dh_testdir
+       dh_testroot
+       rm -f build-stamp
+
+       /usr/bin/python setup.py clean --all
+       (cd docs; make -f ../debian/Makefile.docs clean)
+       rm -f pykota/__init__.pyc pykota/version.pyc
+
+       dh_clean 
+
+install: build
+       dh_testdir
+       dh_testroot
+       dh_clean -k 
+       dh_installdirs
+
+       /usr/bin/python setup.py install --prefix=`pwd`/debian/pykota/usr --no-compile
+
+       install -m 644 conf/pykota.conf.sample $(CURDIR)/debian/pykota/etc/pykota/pykota.conf
+       install -m 640 conf/pykotadmin.conf.sample $(CURDIR)/debian/pykota/etc/pykota/pykotadmin.conf
+       install -m 644 debian/etc/default/printquota $(CURDIR)/debian/pykota/etc/default/printquota
+
+       (cd docs; make -f ../debian/Makefile.docs install DESTDIR=$(CURDIR)/debian/pykota/)
+
+
+# Build architecture-dependent files here.
+binary-arch: build install
+# We have nothing to do by default.
+
+# Build architecture-independent files here.
+binary-arch: build install
+       dh_testdir
+       dh_testroot
+       dh_installchangelogs 
+       dh_installdocs
+       dh_installexamples
+#      dh_install
+#      dh_installmenu
+#      dh_installdebconf       
+#      dh_installlogrotate
+#      dh_installemacsen
+#      dh_installpam
+#      dh_installmime
+#      dh_installinit
+       dh_installcron
+#      dh_installinfo
+       dh_installman
+       dh_link
+#      dh_strip
+       dh_compress
+       dh_fixperms
+#      dh_perl
+       dh_python
+#      dh_makeshlibs
+       dh_installdeb
+#      dh_shlibdeps
+       dh_gencontrol
+       dh_md5sums
+       dh_builddeb
+
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install
Index: pykota/trunk/debian/examples
===================================================================
--- pykota/trunk/debian/examples (revision 1350)
+++ pykota/trunk/debian/examples (revision 1350)
@@ -0,0 +1,6 @@
+initscripts/postgresql/pykota-postgresql.sql
+initscripts/ldap/pykota.schema
+initscripts/ldap/pykota-sample.ldif
+conf/pykota.conf.sample
+conf/pykotadmin.conf.sample
+untested