Index: /pykota/trunk/contributed/Makefile.am
===================================================================
--- /pykota/trunk/contributed/Makefile.am (revision 1417)
+++ /pykota/trunk/contributed/Makefile.am (revision 1417)
@@ -0,0 +1,7 @@
+pykotacontribdir = $(datadir)/doc/pykota/contributed
+pykotacontrib_DATA = 	\
+	pagecount.pl		\
+	README
+
+EXTRA_DIST = \
+	$(pykotacontrib_DATA)
Index: /pykota/trunk/conf/Makefile.am
===================================================================
--- /pykota/trunk/conf/Makefile.am (revision 1417)
+++ /pykota/trunk/conf/Makefile.am (revision 1417)
@@ -0,0 +1,9 @@
+# FIXME, for now you can't change sysconf
+#
+pykotaconfdir = $(sysconfdir)/pykota
+pykotaconf_DATA = 			\
+	pykota.conf.sample 		\
+	pykotadmin.conf.sample
+
+EXTRA_DIST = \
+	$(pykotaconf_DATA)
Index: /pykota/trunk/configure.in
===================================================================
--- /pykota/trunk/configure.in (revision 1417)
+++ /pykota/trunk/configure.in (revision 1417)
@@ -0,0 +1,43 @@
+AC_INIT(pykota/tool.py)
+
+AM_CONFIG_HEADER(config.h)
+AM_INIT_AUTOMAKE(pykota, 1.18alpha14_unofficial)
+
+AM_MAINTAINER_MODE
+
+
+dnl check for python
+dnl AM_PATH_PYTHON(2.2)
+AM_PATH_PYTHON
+
+
+GETTEXT_PACKAGE=pykota
+AC_SUBST(GETTEXT_PACKAGE)
+AC_DEFINE_UNQUOTED(GETTEXT_PACKAGE, "$GETTEXT_PACKAGE", [The gettext package])
+AM_GNU_GETTEXT
+AM_GNU_GETTEXT_VERSION(0.12.1)
+AM_PO_SUBDIRS(po)
+
+AC_OUTPUT([
+intl/Makefile 
+Makefile
+pykota/Makefile
+pykota/accounters/Makefile
+pykota/loggers/Makefile
+pykota/reporters/Makefile
+pykota/requesters/Makefile
+pykota/storages/Makefile
+bin/Makefile
+untested/Makefile
+untested/netatalk/Makefile
+untested/parallel/Makefile
+untested/pjl/Makefile
+untested/postscript/Makefile
+conf/Makefile
+man/Makefile
+openoffice/Makefile
+initscripts/Makefile
+initscripts/ldap/Makefile
+initscripts/postgresql/Makefile
+po/Makefile.in
+])
Index: /pykota/trunk/untested/netatalk/Makefile.am
===================================================================
--- /pykota/trunk/untested/netatalk/Makefile.am (revision 1417)
+++ /pykota/trunk/untested/netatalk/Makefile.am (revision 1417)
@@ -0,0 +1,7 @@
+pykotanetatalkdir = $(datadir)/pykota
+pykotanetatalk_DATA = 	\
+	netatalk.sh			\
+	pagecount.ps
+
+EXTRA_DIST = \
+	$(pykotanetatalk_DATA)
Index: /pykota/trunk/untested/pjl/Makefile.am
===================================================================
--- /pykota/trunk/untested/pjl/Makefile.am (revision 1417)
+++ /pykota/trunk/untested/pjl/Makefile.am (revision 1417)
@@ -0,0 +1,7 @@
+pykotapjldir = $(datadir)/pykota
+pykotapjl_DATA = 	\
+	pagecount.pjl	\
+	status.pjl
+
+EXTRA_DIST = \
+	$(pykotapjl_DATA)
Index: /pykota/trunk/untested/Makefile.am
===================================================================
--- /pykota/trunk/untested/Makefile.am (revision 1417)
+++ /pykota/trunk/untested/Makefile.am (revision 1417)
@@ -0,0 +1,1 @@
+SUBDIRS = netatalk parallel pjl postscript
Index: /pykota/trunk/untested/postscript/Makefile.am
===================================================================
--- /pykota/trunk/untested/postscript/Makefile.am (revision 1417)
+++ /pykota/trunk/untested/postscript/Makefile.am (revision 1417)
@@ -0,0 +1,6 @@
+pykotapostscriptdir = $(datadir)/pykota
+pykotapostscript_DATA = 	\
+	pagecount.sh
+
+EXTRA_DIST =	\
+	$(pykotapostscript_DATA)
Index: /pykota/trunk/untested/parallel/Makefile.am
===================================================================
--- /pykota/trunk/untested/parallel/Makefile.am (revision 1417)
+++ /pykota/trunk/untested/parallel/Makefile.am (revision 1417)
@@ -0,0 +1,6 @@
+pykotaparalleldir = $(datadir)/pykota
+pykotaparallel_DATA = 	\
+	parallel.sh
+	
+EXTRA_DIST = \
+	$(pykotaparallel_DATA)
Index: /pykota/trunk/acinclude.m4
===================================================================
--- /pykota/trunk/acinclude.m4 (revision 1417)
+++ /pykota/trunk/acinclude.m4 (revision 1417)
@@ -0,0 +1,26 @@
+dnl From msw.
+dnl
+dnl a macro to check for ability to create python extensions
+dnl  AM_CHECK_PYTHON_HEADERS([ACTION-IF-POSSIBLE], [ACTION-IF-NOT-POSSIBLE])
+dnl function also defines PYTHON_INCLUDES
+AC_DEFUN([AM_CHECK_PYTHON_HEADERS],
+[AC_REQUIRE([AM_PATH_PYTHON])
+AC_MSG_CHECKING(for headers required to compile python extensions)
+dnl deduce PYTHON_INCLUDES
+py_prefix=`$PYTHON -c "import sys; print sys.prefix"`
+py_exec_prefix=`$PYTHON -c "import sys; print sys.exec_prefix"`
+PYTHON_INCLUDES="-I${py_prefix}/include/python${PYTHON_VERSION}"
+if test "$py_prefix" != "$py_exec_prefix"; then
+  PYTHON_INCLUDES="$PYTHON_INCLUDES -I${py_exec_prefix}/include/python${PYTHON_VERSION}"
+fi
+AC_SUBST(PYTHON_INCLUDES)
+dnl check if the headers exist:
+save_CPPFLAGS="$CPPFLAGS"
+CPPFLAGS="$CPPFLAGS $PYTHON_INCLUDES"
+AC_TRY_CPP([#include <Python.h>],dnl
+[AC_MSG_RESULT(found)
+$1],dnl
+[AC_MSG_RESULT(not found)
+$2])
+CPPFLAGS="$save_CPPFLAGS"
+])
Index: /pykota/trunk/pykota/loggers/Makefile.am
===================================================================
--- /pykota/trunk/pykota/loggers/Makefile.am (revision 1417)
+++ /pykota/trunk/pykota/loggers/Makefile.am (revision 1417)
@@ -0,0 +1,6 @@
+pykota_loggersdir = $(pythondir)/pykota/loggers
+
+pykota_loggers_PYTHON = 	\
+	__init__.py				\
+	stderr.py				\
+	system.py
Index: /pykota/trunk/pykota/requesters/Makefile.am
===================================================================
--- /pykota/trunk/pykota/requesters/Makefile.am (revision 1417)
+++ /pykota/trunk/pykota/requesters/Makefile.am (revision 1417)
@@ -0,0 +1,7 @@
+pykota_requestersdir = $(pythondir)/pykota/requesters
+
+pykota_requesters_PYTHON = 	\
+	external.py				\
+	__init__.py				\
+	snmp.py
+
Index: /pykota/trunk/pykota/reporters/Makefile.am
===================================================================
--- /pykota/trunk/pykota/reporters/Makefile.am (revision 1417)
+++ /pykota/trunk/pykota/reporters/Makefile.am (revision 1417)
@@ -0,0 +1,7 @@
+pykota_reportersdir = $(pythondir)/pykota/reporters
+
+pykota_reporters_PYTHON = 	\
+	html.py					\
+	__init__.py				\
+	text.py
+
Index: /pykota/trunk/pykota/accounters/Makefile.am
===================================================================
--- /pykota/trunk/pykota/accounters/Makefile.am (revision 1417)
+++ /pykota/trunk/pykota/accounters/Makefile.am (revision 1417)
@@ -0,0 +1,8 @@
+pykota_accountersdir = $(pythondir)/pykota/accounters
+
+pykota_accounters_PYTHON = 	\
+	external.py				\
+	__init__.py				\
+	querying.py				\
+	stupid.py				
+
Index: /pykota/trunk/pykota/storages/Makefile.am
===================================================================
--- /pykota/trunk/pykota/storages/Makefile.am (revision 1417)
+++ /pykota/trunk/pykota/storages/Makefile.am (revision 1417)
@@ -0,0 +1,9 @@
+pykota_storagesdir = $(pythondir)/pykota/storages
+
+pykota_storages_PYTHON = 	\
+	dbistorage.py			\
+	__init__.py				\
+	ldapstorage.py			\
+	pgstorage.py			\
+	sql.py
+
Index: /pykota/trunk/pykota/Makefile.am
===================================================================
--- /pykota/trunk/pykota/Makefile.am (revision 1417)
+++ /pykota/trunk/pykota/Makefile.am (revision 1417)
@@ -0,0 +1,15 @@
+pykotadir = $(pythondir)/pykota
+
+pykota_PYTHON = 	\
+	accounter.py	\
+	config.py		\
+	__init__.py		\
+	logger.py		\
+	reporter.py		\
+	requester.py	\
+	storage.py		\
+	tool.py			\
+	version.py
+
+SUBDIRS = accounters loggers reporters requesters storages
+
Index: /pykota/trunk/pykota/version.py
===================================================================
--- /pykota/trunk/pykota/version.py (revision 1415)
+++ /pykota/trunk/pykota/version.py (revision 1417)
@@ -22,5 +22,5 @@
 #
 
-__version__ = "1.18_unofficial"
+__version__ = "1.19alpha1_unofficial"
 
 __doc__ = """PyKota : a complete Printing Quota Solution for CUPS and LPRng."""
Index: /pykota/trunk/bin/Makefile.am
===================================================================
--- /pykota/trunk/bin/Makefile.am (revision 1417)
+++ /pykota/trunk/bin/Makefile.am (revision 1417)
@@ -0,0 +1,20 @@
+bin_SCRIPTS = edpykota snmpprinterstatus repykota warnpykota pykotme pkprinters pkhint
+
+pykotasharedir = $(datadir)/pykota
+pykotashare_DATA = 		\
+	cupspykota			\
+	mailandpopup.sh		\
+	papwaitprinter.sh	\
+	pykota				\
+	waitprinter.sh
+
+EXTRA_DIST = 			\
+	$(bin_SCRIPTS)		\
+	$(pykotashare_DATA)
+#	edpykota 			\
+#	snmpprinterstatus 	\
+#	repykota 			\
+#	warnpykota 			\
+#	pykotme 			\
+#	pkprinters 			\
+#	pkhint
Index: /pykota/trunk/Makefile.am
===================================================================
--- /pykota/trunk/Makefile.am (revision 1417)
+++ /pykota/trunk/Makefile.am (revision 1417)
@@ -0,0 +1,22 @@
+SUBDIRS = intl pykota bin conf untested man openoffice initscripts po
+
+pykotadocdir = $(datadir)/doc/pykota
+pykotadoc_DATA = 		\
+	README				\
+	FAQ					\
+	SECURITY			\
+	COPYING				\
+	LICENSE				\
+	CREDITS				\
+	TODO				\
+	NEWS				
+
+pykotaesdocdir = $(datadir)/doc/pykota/spanish
+pykotaesdoc_DATA = 		\
+	docs/spanish/instalacion.sxw
+
+EXTRA_DIST = config.rpath  \
+	$(pykotadoc_DATA)	\
+	$(pykotaesdoc_DATA)
+
+ACLOCAL_AMFLAGS = -I m4
Index: /pykota/trunk/autogen.sh
===================================================================
--- /pykota/trunk/autogen.sh (revision 1417)
+++ /pykota/trunk/autogen.sh (revision 1417)
@@ -0,0 +1,138 @@
+#!/bin/sh
+# Run this to generate all the initial makefiles, etc.
+
+srcdir=`dirname $0`
+test -z "$srcdir" && srcdir=.
+
+ORIGDIR=`pwd`
+cd $srcdir
+
+ PROJECT=pykota
+
+ CONFIGURE=configure.in
+
+ TEST_TYPE=-f
+ 
+ DIE=0
+
+
+ for autoconf in autoconf autoconf-2.57 autoconf-2.56 autoconf-2.55 autoconf-2.54 autoconf-2.53 autoconf-2.52 ; do
+ 	if "$autoconf" --version < /dev/null > /dev/null 2>&1 ; then
+ 		version=`"$autoconf" --version | head -1 | awk '{print $NF}'`
+ 		acmajor=`echo "$version" | cut -f1 -d.`
+ 		acminor=`echo "$version" | cut -f2 -d.`
+ 		if test "$acmajor" -gt 3 ; then
+ 			break
+ 		fi
+ 		if test "$acmajor" -ge 2 ; then
+ 			if test "$acminor" -ge 50 ; then
+ 				break
+ 			fi
+ 		fi
+ 	fi
+ done
+ if ! "$autoconf" --version < /dev/null > /dev/null 2>&1 ; then
+
+ 	echo
+
+ 	echo "You must have autoconf 2.52 installed to compile $PROJECT."
+
+ 	echo "Install the appropriate package for your distribution,"
+
+ 	echo "or get the source tarball at ftp://ftp.gnu.org/pub/gnu/"
+
+ 	DIE=1
+
+ fi
+ autoheader=`echo "$autoconf" | sed s,autoconf,autoheader,g`
+
+ have_automake=false
+
+ for automakev in 1.7 1.6 ; do
+
+ 	if automake-$automakev --version < /dev/null > /dev/null 2>&1 ; then
+
+ 		have_automake=true
+
+ 		break;
+ 	fi
+ done
+
+ if $have_automake ; then : ; else
+ 	echo
+
+ 	echo "You must have automake 1.6 installed to compile $PROJECT."
+ 	echo "Get ftp://ftp.gnu.org/pub/gnu/automake/automake-1.6.tar.gz"
+
+ 	echo "(or a newer version if it is available)"
+ 	DIE=1
+ fi
+ 
+ if test "$DIE" -eq 1; then
+ 	exit 1
+ fi
+ 
+ if test -z "$AUTOGEN_SUBDIR_MODE"; then
+         if test -z "$*"; then
+                 echo "I am going to run ./configure with no arguments - if you wish "
+                 echo "to pass any to it, please specify them on the $0 command line."
+         fi
+ fi
+ 
+ case $CC in
+ *xlc | *xlc\ * | *lcc | *lcc\ *) am_opt=--include-deps;;
+ esac
+
+ if grep "^AM_[A-Z0-9_]\{1,\}_GETTEXT" "$CONFIGURE" >/dev/null; then
+  if grep "sed.*POTFILES" "$CONFIGURE" >/dev/null; then
+    GETTEXTIZE=""
+  else
+    if grep "^AM_GLIB_GNU_GETTEXT" "$CONFIGURE" >/dev/null; then
+      GETTEXTIZE="glib-gettextize"
+      GETTEXTIZE_URL="ftp://ftp.gtk.org/pub/gtk/v2.0/glib-2.0.0.tar.gz"
+    else
+      GETTEXTIZE="gettextize"
+      GETTEXTIZE_URL="ftp://alpha.gnu.org/gnu/gettext-0.10.35.tar.gz"
+    fi
+                                                                                                                                                                                   
+    $GETTEXTIZE --version < /dev/null > /dev/null 2>&1
+    if test $? -ne 0; then
+      echo
+      echo "**Error**: You must have \`$GETTEXTIZE' installed to compile $PKG_NAME."
+      echo "Get $GETTEXTIZE_URL"
+      echo "(or a newer version if it is available)"
+      DIE=1
+    fi
+  fi
+fi
+
+
+ touch config.h.in
+
+ echo "running autopoint --force --copy"
+ autopoint --force 
+
+ echo "running aclocal-$automakev $ACLOCAL_FLAGS"
+ aclocal-$automakev $ACLOCAL_FLAGS
+
+ echo "running $autoheader"
+ $autoheader
+
+ echo "running automake-$automakev -a -c $am_opt --foreign"
+ automake-$automakev -a -c $am_opt --foreign
+
+ echo "$autoconf"
+ $autoconf
+
+ cd $ORIGDIR
+ 
+ if test -z "$AUTOGEN_SUBDIR_MODE"; then
+    $srcdir/configure --enable-maintainer-mode "$@"
+
+ 	chmod -Rf u+w $srcdir
+
+    echo 
+    echo "Now type 'make' to compile $PROJECT."
+
+ fi
+
Index: /pykota/trunk/initscripts/ldap/Makefile.am
===================================================================
--- /pykota/trunk/initscripts/ldap/Makefile.am (revision 1417)
+++ /pykota/trunk/initscripts/ldap/Makefile.am (revision 1417)
@@ -0,0 +1,8 @@
+pykotadocldapdir = $(datadir)/doc/pykota/
+pykotadocldap_DATA = 	\
+	pykota-sample.ldif	\
+	pykota.schema		\
+	README.ldap
+	
+EXTRA_DIST = \
+	$(pykotadocldap_DATA)
Index: /pykota/trunk/initscripts/postgresql/Makefile.am
===================================================================
--- /pykota/trunk/initscripts/postgresql/Makefile.am (revision 1417)
+++ /pykota/trunk/initscripts/postgresql/Makefile.am (revision 1417)
@@ -0,0 +1,12 @@
+pykotadopostgresdir = $(datadir)/doc/pykota/
+pykotadopostgres_DATA = 		\
+	dbschema.png				\
+	pykota-postgresql.sql		\
+	README.postgresql			\
+	upgrade-from-before-1.03.py	\
+	upgrade-to-1.14.sql			\
+	upgrade-to-1.16.sql			\
+	VERYOLDpykota-upgrade-postgresql.sql
+
+EXTRA_DIST = \
+	$(pykotadopostgres_DATA)
Index: /pykota/trunk/initscripts/Makefile.am
===================================================================
--- /pykota/trunk/initscripts/Makefile.am (revision 1417)
+++ /pykota/trunk/initscripts/Makefile.am (revision 1417)
@@ -0,0 +1,1 @@
+SUBDIRS = ldap postgresql
Index: /pykota/trunk/man/Makefile.am
===================================================================
--- /pykota/trunk/man/Makefile.am (revision 1417)
+++ /pykota/trunk/man/Makefile.am (revision 1417)
@@ -0,0 +1,13 @@
+pykotamandir = $(mandir)/man1
+pykotaman_DATA = 		\
+	edpykota.1			\
+	papwaitprinter.sh.1	\
+	pkhint.1			\
+	pkprinters.1		\
+	pykotme.1			\
+	repykota.1			\
+	waitprinter.sh.1	\
+	warnpykota.1
+
+EXTRA_DIST =	\
+	$(pykotaman_DATA)
Index: /pykota/trunk/NEWS
===================================================================
--- /pykota/trunk/NEWS (revision 1415)
+++ /pykota/trunk/NEWS (revision 1417)
@@ -22,4 +22,8 @@
 PyKota NEWS :
 
+    - 1.19alpha1 : 
+    
+        - Inclusion of Michele Baldessari's work on autotools.
+        
     - 1.18 :
     
Index: /pykota/trunk/openoffice/Makefile.am
===================================================================
--- /pykota/trunk/openoffice/Makefile.am (revision 1417)
+++ /pykota/trunk/openoffice/Makefile.am (revision 1417)
@@ -0,0 +1,11 @@
+pykotadocoodir = $(datadir)/doc/pykota/openoffice
+pykotadocoo_DATA = 		\
+	gODBCConfig1.png	\
+	gODBCConfig2.png	\
+	ooo1.png			\
+	ooo2.png			\
+	README				\
+	samplereport.pdf	\
+	samplereport.sxc
+EXTRA_DIST = \
+	$(pykotadocoo_DATA)