Index: pykota/trunk/initscripts/ldap/pykota.schema
===================================================================
--- pykota/trunk/initscripts/ldap/pykota.schema (revision 1455)
+++ pykota/trunk/initscripts/ldap/pykota.schema (revision 1473)
@@ -169,4 +169,11 @@
         SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
 
+# pykotaHostName
+attributetype ( 1.3.6.1.4.1.16868.1.1.24 NAME 'pykotaHostName'
+        DESC 'The host the job is coming from'
+        EQUALITY caseIgnoreMatch
+        SUBSTR caseIgnoreSubstringsMatch
+        SYNTAX 1.3.6.1.4.1.1466.115.121.1.15{256} )
+
 #        
 # PyKota Object Classes
@@ -207,5 +214,5 @@
         DESC 'An entry in the job history for a printer'
         MUST ( cn $ pykotaUserName $ pykotaPrinterName $ pykotaJobId )
-        MAY  ( pykotaPrinterPageCounter $ pykotaJobSize $ pykotaAction $ pykotaJobPrice $ pykotaFileName $ pykotaTitle $ pykotaCopies $ pykotaOptions ) )
+        MAY  ( pykotaPrinterPageCounter $ pykotaJobSize $ pykotaAction $ pykotaJobPrice $ pykotaFileName $ pykotaTitle $ pykotaCopies $ pykotaOptions $ pykotaHostName ) )
         
 # pykotaAccountBalance
Index: pykota/trunk/initscripts/postgresql/README.postgresql
===================================================================
--- pykota/trunk/initscripts/postgresql/README.postgresql (revision 1257)
+++ pykota/trunk/initscripts/postgresql/README.postgresql (revision 1473)
@@ -59,4 +59,15 @@
   version of PyKota.
   
+  * An SQL script to upgrade a 1.18 PyKota Storage DataBase to
+    1.19 is included. Launch it this way on the Quota Storage Server :
+    
+        $ psql -U postgres pykota
+        pykota=# \i upgrade-to-1.19.sql
+        pykota=# \q
+        $
+        
+    This script adds a field to the print job history. The field that
+    is added is : hostname
+    
   * An SQL script to upgrade a pre-1.16 PyKota Storage DataBase to
     1.16 is included. Launch it this way on the Quota Storage Server :
Index: pykota/trunk/initscripts/postgresql/pykota-postgresql.sql
===================================================================
--- pykota/trunk/initscripts/postgresql/pykota-postgresql.sql (revision 1257)
+++ pykota/trunk/initscripts/postgresql/pykota-postgresql.sql (revision 1473)
@@ -20,4 +20,7 @@
 --
 -- $Log$
+-- Revision 1.9  2004/05/13 11:15:29  jalet
+-- Added hostname field in job history
+--
 -- Revision 1.8  2004/01/08 14:10:32  jalet
 -- Copyright year changed.
@@ -118,4 +121,5 @@
                         userid INT4,
                         printerid INT4,
+                        hostname TEXT,
                         pagecounter INT4 DEFAULT 0,
                         jobsize INT4,
Index: pykota/trunk/initscripts/postgresql/upgrade-to-1.19.sql
===================================================================
--- pykota/trunk/initscripts/postgresql/upgrade-to-1.19.sql (revision 1473)
+++ pykota/trunk/initscripts/postgresql/upgrade-to-1.19.sql (revision 1473)
@@ -0,0 +1,42 @@
+--
+-- PyKota - Print Quotas for CUPS and LPRng
+--
+-- (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+-- This program is free software; you can redistribute it and/or modify
+-- it under the terms of the GNU General Public License as published by
+-- the Free Software Foundation; either version 2 of the License, or
+-- (at your option) any later version.
+--
+-- This program is distributed in the hope that it will be useful,
+-- but WITHOUT ANY WARRANTY; without even the implied warranty of
+-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+-- GNU General Public License for more details.
+-- 
+-- You should have received a copy of the GNU General Public License
+-- along with this program; if not, write to the Free Software
+-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+--
+-- $Id$
+--
+-- $Log$
+-- Revision 1.1  2004/05/13 11:15:29  jalet
+-- Added hostname field in job history
+--
+--
+--
+-- This script has to be used if you already
+-- have a pre-1.19 version of PyKota to upgrade
+-- your database schema. 
+--
+-- YOU DON'T NEED TO USE IT IF YOU'VE JUST INSTALLED PYKOTA
+--
+                        
+--                         
+-- WARNING : YOU NEED A RECENT VERSION OF POSTGRESQL FOR THE ALTER COLUMN STATEMENT TO WORK !
+--
+
+--                         
+-- Modify the old database schema
+--
+ALTER TABLE jobhistory ADD COLUMN hostname TEXT;
+
Index: pykota/trunk/initscripts/README
===================================================================
--- pykota/trunk/initscripts/README (revision 1257)
+++ pykota/trunk/initscripts/README (revision 1473)
@@ -45,4 +45,10 @@
 =============================================================================
     
+  * upgrade-to-1.19.sql :  
+  
+    This file upgrades the PostgreSQL Quota Storage Database schema
+    from versions before 1.19alpha7 to version 1.19alpha7 and above.
+    NEVER USE IT IF YOU ALREADY RUN 1.19alpha7 OR ABOVE !
+    
   * upgrade-to-1.16.sql :  
   